## org.eclipse.jetty.server.handler
Class ErrorHandler

    java.lang.Object
      org.eclipse.jetty.util.component.AbstractLifeCycle
          org.eclipse.jetty.server.handler.AbstractHandler
              org.eclipse.jetty.server.handler.ErrorHandler

All Implemented Interfaces:
  Handler, LifeCycle

Direct Known Subclasses:
  ErrorPageErrorHandler

    public class ErrorHandler

extends AbstractHandler

Handler for Error pages An ErrorHandler is registered with `ContextHandler.setErrorHandler(ErrorHandler)` or `Server.addBean(Object)`. It is called by the HttpResponse.sendError method to write a error page.

Nested Class Summary

Nested classes/interfaces inherited from class org.eclipse.jetty.util.component.AbstractLifeCycle
`AbstractLifeCycle.AbstractLifeCycleListener`

Nested classes/interfaces inherited from interface org.eclipse.jetty.util.component.LifeCycle
`LifeCycle.Listener`

Field Summary

Fields inherited from class org.eclipse.jetty.util.component.AbstractLifeCycle
`_listeners, FAILED, RUNNING, STARTED, STARTING, STOPPED, STOPPING`

Constructor Summary
`ErrorHandler()`

Method Summary
`java.lang.String` `getCacheControl()` Get the cacheControl.
`void` `handle(java.lang.String target, Request baseRequest, HttpServletRequest request, HttpServletResponse response)` Handle a request.
`protected void` `handleErrorPage(HttpServletRequest request, java.io.Writer writer, int code, java.lang.String message)`
`boolean` `isShowStacks()`
`void` `setCacheControl(java.lang.String cacheControl)` Set the cacheControl.
`void` `setShowStacks(boolean showStacks)`
`protected void` `write(java.io.Writer writer, java.lang.String string)`
`protected void` `writeErrorPage(HttpServletRequest request, java.io.Writer writer, int code, java.lang.String message, boolean showStacks)`
`protected void` `writeErrorPageBody(HttpServletRequest request, java.io.Writer writer, int code, java.lang.String message, boolean showStacks)`
`protected void` `writeErrorPageHead(HttpServletRequest request, java.io.Writer writer, int code, java.lang.String message)`
`protected void` `writeErrorPageMessage(HttpServletRequest request, java.io.Writer writer, int code, java.lang.String message, java.lang.String uri)`
`protected void` `writeErrorPageStacks(HttpServletRequest request, java.io.Writer writer)`

Methods inherited from class org.eclipse.jetty.server.handler.AbstractHandler
`destroy, doStart, doStop, dump, dump, dump, getServer, setServer, toString`

Methods inherited from class org.eclipse.jetty.util.component.AbstractLifeCycle
`addLifeCycleListener, getState, isFailed, isRunning, isStarted, isStarting, isStopped, isStopping, removeLifeCycleListener, start, stop`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface org.eclipse.jetty.util.component.LifeCycle
`addLifeCycleListener, isFailed, isRunning, isStarted, isStarting, isStopped, isStopping, removeLifeCycleListener, start, stop`

Constructor Detail

### ErrorHandler

    public ErrorHandler()

Method Detail

### handle

    public void handle(java.lang.String target,
                       Request baseRequest,
                       HttpServletRequest request,
                       HttpServletResponse response)
                throws java.io.IOException

  Description copied from interface: `Handler`
  Handle a request.

  Parameters:
    `target` - The target of the request - either a URI or a name.
    `baseRequest` - The original unwrapped request object.
    `request` - The request either as the `Request` object or a wrapper of that request. The `HttpConnection.getCurrentConnection()` method can be used access the Request object if required.
    `response` - The response as the `Response` object or a wrapper of that request. The `HttpConnection.getCurrentConnection()` method can be used access the Response object if required.
  Throws:
    `java.io.IOException`

### handleErrorPage

    protected void handleErrorPage(HttpServletRequest request,
                                   java.io.Writer writer,
                                   int code,
                                   java.lang.String message)
                            throws java.io.IOException

  Throws:
    `java.io.IOException`

### writeErrorPage

    protected void writeErrorPage(HttpServletRequest request,
                                  java.io.Writer writer,
                                  int code,
                                  java.lang.String message,
                                  boolean showStacks)
                           throws java.io.IOException

  Throws:
    `java.io.IOException`

### writeErrorPageHead

    protected void writeErrorPageHead(HttpServletRequest request,
                                      java.io.Writer writer,
                                      int code,
                                      java.lang.String message)
                               throws java.io.IOException

  Throws:
    `java.io.IOException`

### writeErrorPageBody

    protected void writeErrorPageBody(HttpServletRequest request,
                                      java.io.Writer writer,
                                      int code,
                                      java.lang.String message,
                                      boolean showStacks)
                               throws java.io.IOException

  Throws:
    `java.io.IOException`

### writeErrorPageMessage

    protected void writeErrorPageMessage(HttpServletRequest request,
                                         java.io.Writer writer,
                                         int code,
                                         java.lang.String message,
                                         java.lang.String uri)
                                  throws java.io.IOException

  Throws:
    `java.io.IOException`

### writeErrorPageStacks

    protected void writeErrorPageStacks(HttpServletRequest request,
                                        java.io.Writer writer)
                                 throws java.io.IOException

  Throws:
    `java.io.IOException`

### getCacheControl

    public java.lang.String getCacheControl()

  Get the cacheControl.

  Returns:
    the cacheControl header to set on error responses.

### setCacheControl

    public void setCacheControl(java.lang.String cacheControl)

  Set the cacheControl.

  Parameters:
    `cacheControl` - the cacheControl header to set on error responses.

### isShowStacks

    public boolean isShowStacks()

  Returns:
    True if stack traces are shown in the error pages

### setShowStacks

    public void setShowStacks(boolean showStacks)

  Parameters:
    `showStacks` - True if stack traces are shown in the error pages

### write

    protected void write(java.io.Writer writer,
                         java.lang.String string)
                  throws java.io.IOException

  Throws:
    `java.io.IOException`

Copyright © 1995-2010 Mort Bay Consulting. All Rights Reserved.